<p align="center">
  <a href="https://reactcosmos.org"><img alt="Cosmos" src="cosmos.png"></a>
</p>

# React Cosmos

[![npm version](https://img.shields.io/npm/v/react-cosmos.svg?style=flat)](https://www.npmjs.com/package/react-cosmos) [![CircleCI Status](https://circleci.com/gh/react-cosmos/react-cosmos.svg?style=shield)](https://circleci.com/gh/react-cosmos/react-cosmos) [![Twitter](https://img.shields.io/twitter/follow/ReactCosmos.svg?color=%2338A1F3&label=twitter&style=flat)](https://twitter.com/ReactCosmos) [![Slack](https://join-react-cosmos.now.sh/badge.svg)](https://join-react-cosmos.now.sh/) [![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg)](https://github.com/react-cosmos/react-cosmos/blob/master/CONTRIBUTING.md#how-to-contribute)

A dev environment for building scalable, high-quality user interfaces.

- **Visual TDD.** Develop one component at a time. Isolate the UI you&apos;re
  working on and iterate quickly. Reloading your whole app on
  every change is slowing you down!
- **Component library.** Bookmark component states, from blank states to edge
  cases. Your component library keeps you organized and provides a solid
  foundation of test cases.
- **Open platform.** React Cosmos can be used in powerful ways. Including
  snapshot and visual regression testing, as well as custom integrations
  tailored to your needs.

👩‍🚀 [Live demo](https://reactcosmos.org/live-demo/) · 📜 [Documentation](docs) · 💰[Sponsor](https://github.com/users/skidding/sponsorship)

[![React Cosmos](next.png)](https://reactcosmos.org)

## 🤔 Why React Cosmos?

React Cosmos

- **Makes developers more productive**
- **Leads to high-quality, reusable UI components**
- Makes it easy to share component libraries
- Helps with automated testing

React Cosmos is

- **An isolated component environment**
- **Simple, detail-oriented and battle-tested**
- The result of over 5 years of fine-tuning
- React-only
- Compatible with other bundlers (aside from webpack)

React Cosmos is **not**

- A [style guide](https://react-styleguidist.js.org) generator
- A [documentation](https://www.docz.site) tool
- A [testing](https://github.com/testing-library/react-testing-library) framework

> [Many other](https://react-styleguidist.js.org/docs/cookbook.html#are-there-any-other-projects-like-this) similar tools have emerged since React Cosmos was [created](https://www.youtube.com/watch?v=t9V2oKK83Kg). Choose wisely based on your unique needs and personal taste.

### A Brief History of React Cosmos

- 📢 2014 [Cosmos.js, autonomous components for scaling user interfaces](https://www.reddit.com/r/javascript/comments/252cdy/cosmosjs_autonomous_components_for_scaling_user/) | Reddit
- 📺 2015 [Can components be truly encapsulated?](https://www.youtube.com/watch?v=t9V2oKK83Kg) | React Europe
- 📝 2016 [Fighting for Component Independence](https://medium.com/@skidding/fighting-for-component-independence-2a762ee53272) | Medium
- 📺 2017 [UI Development Made Simple](https://www.youtube.com/watch?v=C3tx999wbgM) | JSHeroes
- 🐦 2019 [React Cosmos 5 in 21 tweets](https://twitter.com/ReactCosmos/status/1189127279533793281) | Twitter
- 💬 2019 [I made a tool for creating React components with visual TDD](https://sourcesort.com/interview/ovidiu-chereches-react-cosmos) | SourceSort

## 🎞 Credits

Hi there. I'm [Ovidiu](https://twitter.com/skidding), the core maintainer of React Cosmos. I spend ridiculous amounts of time perfecting this project because I love building user interfaces and making useful things.

React Cosmos is licensed as MIT and will always be free. If you want to support me, however, [become a Sponsor](https://github.com/users/skidding/sponsorship) and ensure this journey continues!

Special thanks to

- [@maxsalven](https://github.com/maxsalven) and [@xavxyz](https://github.com/xavxyz) for the long conversations and recurring support along the years.
- [@catalinmiron](https://github.com/catalinmiron), [@flaviusone](https://github.com/flaviusone), [@NiGhTTraX](https://github.com/NiGhTTraX), [@ovidiubute](https://github.com/ovidiubute), [@RadValentin](https://github.com/RadValentin), [@tkjone](https://github.com/tkjone), and all the other [contributors](https://github.com/react-cosmos/react-cosmos/graphs/contributors).
- [Kreativa Studio](http://www.kreativa-studio.com/) for the iconic Cosmonaut illustration.

**❤️ React Cosmos is still alive because of you!**

<p align="center">🌤</p>
